/**
 * created by wy
 * 小易主页部分
 * 包含整体通用函数、小易按钮、主面板、消息免打扰
 **/


/*-------------------------小易整体通用函数部分-------------------*/

/*---延时hover事件---*/
(function($){
    $.fn.hoverDelay = function(options){
        var defaults = {
            hoverDuring: 600,
            outDuring: 0,
            hoverEvent: function(){
                $.noop();
            },
            outEvent: function(){
                $.noop();
            }
        };
        var sets = $.extend(defaults,options || {});
        var hoverTimer, outTimer;
        return $(this).each(function(){
            $(this).hover(function(){
                clearTimeout(outTimer);
                hoverTimer = setTimeout(sets.hoverEvent, sets.hoverDuring);
            },function(){
                clearTimeout(hoverTimer);
                outTimer = setTimeout(sets.outEvent, sets.outDuring);
            });
        });
    }
})(jQuery);
/*---输入查询条件监听回车事件---*/
document.onkeydown=function(e){
    var theEvent = window.event||e;//兼容ff
    var code = theEvent.keyCode || theEvent.which;
    //刷新模块列表
    if(code == 13){
        if($(".module-container").hasClass("module-show-or-not")){
            //刷新模块列表
            var obj=$("#moduleCondition").val()||null;
            getModuleListDs(obj);
            refreshModuleListDigital();
            refreshModuleListLetter();
        }
    }
    //刷新其他
    var currentTabList = $(".use-easy-common-container");
    var currentTab=null;
    for(var j=0;j<currentTabList.length;j++){
        if($(currentTabList[j]).css("display")=="block"){
            currentTab = $(currentTabList[j]);
        }
    }
    if(currentTab==null){
        return;
    }
    if (code == 13){
         if(currentTab.hasClass("use-easy-todo-container")){
            todoCurrentPage=1;//重新从第一页开始查
            initMyTodoListTab();
        }else if(currentTab.hasClass("use-easy-application-container")){
            applyCurrentPage=1;
            initMyApplyListTab();
        }else if(currentTab.hasClass("use-easy-approve-container")){
            approveCurrentPage=1;
            initMyApproveListTab();
        }else if(currentTab.hasClass("use-easy-collections-container")){
            //-----刷新我的收藏
            initMyCollectionList();//获取数据
            sortMyCollection();//排序
            getCollectionFirstLetter();//获取首字母
            initMyCollectionTab();//绘制页面
        }else if(currentTab.hasClass("use-easy-collect-notice-container")){
            //----刷新收藏单据动态信息
            collectMessageCurrentPage=1;
            initCollectNoticeMessageTab();
        }else if(currentTab.hasClass("use-easy-noBother-container")){
            //渲染免打扰数据
            botherCurrentPage=1;
            getEventCodeList();
            initMessageNoBotherList();
        }


    }
}
/*---点击任意地方隐藏设置条---*/
document.onclick = function (event) {
    var e = event || window.event;
    var elem = e.srcElement || e.target;
    while (elem) {
        if (elem != document) {
            if (elem.className == "use-easy-noBother-setting"||elem.id=="show-noBother-setting") {
                $(".use-easy-noBother-setting").css("display","block");
                return;
            }
            else if (elem.className == "use-easy-my-apply-setting"||elem.id=="show-my-apply-setting") {
                $(".use-easy-my-apply-setting").css("display","block");
                return;
            }else if(elem.className == "use-easy-my-approve-setting"||elem.id=="show-my-approve-setting"){
                $(".use-easy-my-approve-setting").css("display","block");
                return;
            }
            elem = elem.parentNode;
        } else {
            $(".use-easy-noBother-setting").css("display","none");
            $(".use-easy-my-apply-setting").css("display","none");
            $(".use-easy-my-approve-setting").css("display","none");
            return;
        }
    }
}
/*---控制分页按钮显示---*/
function initPageBtn(type){
    var idPrev = '#'+type+'_foot_btn_prev';
    var idNext = '#'+type+'_foot_btn_next';
    var total = type+"Total";
    var page = type+"CurrentPage";
    var pageSize = type+"PageSize";
    var pageCount = Math.ceil(div(window[total],window[pageSize]));//页数
    var pageInfo = type+"_page_info";
    if(window[total]==0||window[total]<=window[pageSize]){
        $(idPrev).attr("src",contextPath+"/resources/images/CSH/last.png");
        $(idNext).attr("src",contextPath+"/resources/images/CSH/nextNot.png");
    }
    //左灰
    else if(window[page]==1&&window[total]>window[pageSize]){
        $(idPrev).attr("src",contextPath+"/resources/images/CSH/last.png");
        $(idNext).attr("src",contextPath+"/resources/images/CSH/next.png");
    }
    //右灰
    else if(pageCount==window[page]){
        $(idPrev).attr("src",contextPath+"/resources/images/CSH/lastCan.png");
        $(idNext).attr("src",contextPath+"/resources/images/CSH/nextNot.png");
    }else{
        $(idPrev).attr("src",contextPath+"/resources/images/CSH/lastCan.png");
        $(idNext).attr("src",contextPath+"/resources/images/CSH/next.png");
    }
    //修改页码值
    var showPage = window[page];
    if(pageCount==0){
        showPage=0;//当没有数据的时候 当前页码也显示为0
    }
    $("#"+pageInfo).text(showPage+"/"+pageCount);

}
/*---通用分页方法---*/
function changePageInfo(type,direction){
    var idPrev = '#'+type+'_foot_btn_prev';
    var idNext = '#'+type+'_foot_btn_next';
    var total = type+"Total";
    var page = type+"CurrentPage";
    var pageSize = type+"PageSize";
    if(direction=="prev"){
        if(window[page]==1||window[total]==0){
            return;
        }
        window[page] = window[page]-1;
    }else{
        if(Math.ceil(div(window[total],window[pageSize]))==window[page]||window[total]==0){
            return;
        }
        window[page] = window[page]+1;
    }
    //获取数据渲染页面
    if(type=="todo"){
        initMyTodoListTab();//我的待办
    }else if(type=="apply"){
        initMyApplyListTab();//我的申请
    }else if(type=="approve"){
        initMyApproveListTab();//我的审批
    }else if(type=="bother"){
        getEventCodeList();//免打扰设置
        initMessageNoBotherList();
    }else if(type=="collectMessage"){
        initCollectNoticeMessageTab();//收藏消息动态
    }
}
/*---分页按钮点击事件---*/
$(".my-office-page-btn").click(function(){
    //获取类型
    var type = $(this).attr("name").split("-")[1];
    var direction = "";
    //获取方向
    if($(this).attr("id")==type+"_foot_btn_prev"){
        direction = "prev";
    }else{
        direction = "next";
    }
    changePageInfo(type,direction);
})
/*监听滚轮事件实现前后翻页*/
function scrollFunc(e){
    var direction = "";//滚动方向
    var type = "";//要翻页的tab
    if(e.wheelDelta&&e.wheelDelta>0){//IE/Opera/Chrome
        //向上滚动 大于0
        direction = 'prev';
    }else if(e.detail&&e.detail<0){//Firefox
        //向下滚动 大于0
        direction = 'prev';
    }else if(e.wheelDelta&&e.wheelDelta<0){
        direction = 'next';
    }else if(e.detail&&e.detail>0){
        direction = 'next';
    }
    if($(".use-easy-todo-container").css("display")=="block"){
        type='todo';
    }else if($(".use-easy-application-container").css("display")=="block"){
        type='apply';
    }else if($(".use-easy-approve-container").css("display")=="block"){
        type='approve';
    }else if($(".use-easy-collect-notice-container").css("display")=="block"){
        type='collectMessage';
    }else if($(".use-easy-noBother-container").css("display")=="block"){
        type='bother';
    }

    if(direction!=""&&type!=""){
        changePageInfo(type,direction);
    }
    e.stopPropagation();
}
/*-------------------------menu部分------------------------*/
$(document).ready(function(){
    // initEasyIconHover();hover事件
    // 图标点击事件
    initEasyIconClick();
    kendo.bind($(".use-easy-noBother-content"), viewModelEvent);//绑定checkbox
    //绑定滚轮事件
    if(document.addEventListener){
        document.addEventListener('DOMMouseScroll',scrollFunc,false);
    }
    window.onmousewheel=document.onmousewheel=scrollFunc;

})
var hoverFlag=true;//是否可以触发hover事件
/*小易图标hover事件*/
function initEasyIconHover(){
    $(".use-easy-box").hoverDelay({
        hoverEvent: function(){
            if(hoverFlag){
                $(".use-easy-box").animate({
                    width:'170px'
                })
            }
        },
        outEvent:function(){
            if(hoverFlag){
                $(".use-easy-box").animate({
                    width:'30px'
                })
            }
        }
    });
}
/*小易图标点击事件*/
function initEasyIconClick(){
    $("#use-easy-icon").click(function(){
       // hoverFlag=!hoverFlag;//修改是否可触发条件值
        //显示主页
        if($(".use-easy-home-container").css("display")=="none"){
            $(".use-easy-home-container").css("display","block");
            initMyListCount();//初始化我的申请待办审批条数
            initMostVisitModule();//初始化最常访问
            initRecentVisitDoc();//初始化最近访问
        }else{
            $(".use-easy-home-container").css("display","none");
        }
        //隐藏所有其他
        $(".use-easy-common-container").css("display","none");
        //隐藏消息盒子
        $("#notice_ul")[0].style.display="none";
        //隐藏模块列表
        if($(".module-container").hasClass("module-show-or-not")){
            $(".module-container").removeClass("module-show-or-not")
        }
    })
}
/*小易menu里图标点击事件*/
function openUseEasyBoard(e){
    $(".use-easy-home-container").css("display","none");//隐藏首页
      //根据img标签的id不同判断打开哪一部分
    var chooseType = $(e).attr("id").split("-")[2];
      //隐藏
    var siblings = $(e).siblings();
    for(var i=0;i<siblings.length;i++){
        var type = $(siblings[i]).attr("id").split("-")[2];
        var tabName = ".use-easy-"+type+"-container";
        $(tabName).css("display","none");
        if(type=="mail"){
            $("#notice_ul")[0].style.display="none";
        }
    }
      //打开或关闭本身并渲染数据
    if(chooseType=="mail"){
        $("#voice_main_body").empty();
        hlsLoadMainMsg("TODO");
        $("#notice_ul")[0].style.display="block";
    }else if(chooseType=="list"){
        showModuleList();
    }else if(chooseType=="collections"){
        $(".use-easy-collections-container").css("display","block");//打开收藏
        initMyCollectionList();//获取数据
        sortMyCollection();//排序
        getCollectionFirstLetter();//获取首字母
        initMyCollectionTab();//绘制页面

    }else if(chooseType=="settings"){
        $(".use-easy-settings-container").css("display","block");//打开设置
    }
}
/*---------------------------主面板部分------------------------*/
/*最常访问按钮点击事件*/
$(".use-easy-home-top .use-easy-common-button").click(function(){
    //切换自身样式
    $(this).toggleClass("use-easy-common-button-selected");
    //取消其他按钮样式
    $(this).siblings(".use-easy-common-button-selected").toggleClass("use-easy-common-button-selected");
    //打开对应模块
    if($(this).attr("name")!=null&&$(this).attr("name")!=""){
        openTab('', $(this).attr("name").split("-")[0], $(this).attr("name").split("-")[1], '', '', 'Y','','');
    }
})
/*消息免打扰按钮*/
$("#openNoBotherIcon").click(function(){
    //打开免打扰设置面板 隐藏主面板
   $(".use-easy-noBother-container").css("display","block");
   $(".use-easy-home-container").css("display","none");
    //渲染免打扰面板
    botherCurrentPage=1;
    getEventCodeList();//获取数据
    initMessageNoBotherList();//绘制页面
})
/*渲染最常访问模块*/
function initMostVisitModule(){
    $.ajax({
        type: 'GET',
        url: contextPath + '/sys/user/visit/history/queryMostVisitModule?page=1&pageSize=4',
        contentType: "application/json; charset=utf-8",
        async: false,
        success: function (datas) {
            var datasource = datas.rows;
            var dataSourcelength=datas.rows.length;
            $(".use-easy-home-top .use-easy-common-button").each(function (index,item) {
                if(index<dataSourcelength){
                    $(item).text(datasource[index].visitTitle);
                    $(item).attr("name",datasource[index].visitTitle+'-'+datasource[index].visitUrl);
                }

            })

        }
    })
}
/*渲染我的待办、申请、审批条数*/
function initMyListCount(){
    $.ajax({
        type: 'GET',
        url: contextPath + '/ease/my/list/queryMyListCount',
        contentType: "application/json; charset=utf-8",
        async: false,
        success: function (datas) {
            $("#myTodoCount").text(datas.rows[0].todoCount);
            $("#myApplicationCount").text(datas.rows[0].applyCount);
            $("#myApproveCount").text(datas.rows[0].approveCount);
        }
    })
}
/*我的待办点击事件*/
$("#showMyTodoBtn").click(function(){
    $(".use-easy-home-container").css("display","none");
    $(".use-easy-todo-container").css("display","block");
    todoCurrentPage = 1;
    initMyTodoListTab();//获取数据 渲染页面

})
/*我的申请点击事件*/
$("#showMyApplyBtn").click(function(){
    $(".use-easy-home-container").css("display","none");
    $(".use-easy-application-container").css("display","block");
    applyCurrentPage = 1;
    initMyApplyListTab();//获取数据 渲染页面

})
/*我的审批点击事件*/
$("#showMyApproveBtn").click(function(){
    $(".use-easy-home-container").css("display","none");
    $(".use-easy-approve-container").css("display","block");
    approveCurrentPage = 1;
    initMyApproveListTab();//获取数据 渲染页面

})
/*渲染最近访问单据*/
function openRecentDoc(url,visitTitle){
    url = url;
    openTab('', visitTitle, url, '', '', 'Y','','');
}
function initRecentVisitDoc(){
    $.ajax({
        type: 'GET',
        url: contextPath + '/sys/user/visit/history/queryRecentVisitDoc?page=1&pageSize=5',
        contentType: "application/json; charset=utf-8",
        async: false,
        success: function (datas) {
            $(".use-easy-home-bottom p").remove();
            var datasource = datas.rows;
            var dataSourcelength=datas.rows.length;
            for(var i=0;i<dataSourcelength;i++){
                var pSpan = '<p onclick="openRecentDoc(\''+datasource[i].visitUrl+'\',\''+datasource[i].visitTitle+'\')">'+datasource[i].visitTitle+'</p>';
                $(".use-easy-home-bottom").append(pSpan);
            }
        }
    })
}
/*--------------------------免打扰面板部分-------------------------*/
var botherCurrentPage=1;//当前页码
var botherPageSize=10;
var botherTotal=0;//条数
var botherListDs=[];//数据源

/*点击返回按钮*/
$(".use-easy-noBother-title img").click(function(){
    //关闭当前面板 打开主面板
    $(".use-easy-noBother-container").css("display","none");
    $(".use-easy-home-container").css("display","block");
})
/*点击显示设置条事件*/
$("#show-noBother-setting").click(function(){
    $(".use-easy-noBother-setting").css("display","block");
})
/*设置条内按钮点击事件*/
$(".use-easy-nobother-btn").click(function(){
    //切换自身样式
    $(this).toggleClass("use-easy-nobother-btn-selected");
    //取消其他按钮样式
    $(this).siblings(".use-easy-nobother-btn-selected").toggleClass("use-easy-nobother-btn-selected");
    //查询数据
    botherCurrentPage=1;
    getEventCodeList();
    //渲染列表
    initMessageNoBotherList();
})
/*获取事件代码列表*/
function getEventCodeList(){
    var url=contextPath + '/ease/my/event/bother/query?pagesize='+botherPageSize+'&page=' + botherCurrentPage;
    if($("#search-nobother").val()!=null&&$("#search-nobother").val()!=""){
        url = url+'&eventName='+$("#search-nobother").val();
    }
    var selectBtn = $(".use-easy-nobother-btn-selected").eq(0).attr("name");//选中的按钮name属性
    if(selectBtn!="ALL"){
        url = url+"&filterFlag="+selectBtn;
    }
    $.ajax({
        type: 'GET',
        url:  url,
        contentType: "application/json; charset=utf-8",
        async: false,
        success: function (datas) {
            botherListDs = datas.rows;
            botherTotal = datas.total;
            for(var i=0;i<datas.rows.length;i++){
               viewModelEvent.data.set("filterFlag"+i,datas.rows[i].filterFlag);
            }
        }
    })
}
/*渲染免打扰列表*/
function initMessageNoBotherList(){
    var container = $(".use-easy-noBother-item");//获取容器
    container.css("display","block");
    var diff = minus(botherPageSize,botherListDs.length);//页面固定条数与查询结果条数差值
    if(diff>=0){
        for(var i=0;i<botherListDs.length;i++){
            $(".use-easy-noBother-item-eventName").eq(i).text(botherListDs[i].eventName);
            $(".use-easy-noBother-item-filter").eq(i).attr("name",botherListDs[i].eventCode);
        }
    }
    if(diff>0){
        //移除没内容的container
        if(diff==botherPageSize){
            container.css("display","none");
        }else{
            for(var index=(botherPageSize-diff);index<container.length;index++){
                container.eq(index).css("display","none");
            }
        }
    }
    initFilterCheckbox();//绘制checkbox
    //初始化分页按钮
    initPageBtn("bother");

}
/*渲染checkbox*/
var viewModelEvent = kendo.observable({
    data: {
    }
});
function initFilterCheckbox(){
    for(var i=0;i<10;i++){
        var flagId = 'filterFlag'+i;
        var switchSpan = $('#'+flagId+'_switchtest_span');
        var switchSpanSmall = $('#'+flagId+'_switchtest_span_small');
        if(viewModelEvent.data[flagId]=='Y'){
            if(switchSpan.hasClass("switchery-unchecked")){
                switchSpan.removeClass('switchery-unchecked');
            }
            if(switchSpanSmall.hasClass("switchery-span-small-unchecked")){
                switchSpanSmall.removeClass('switchery-span-small-unchecked');
            }
            switchSpan.addClass('switchery-checked');
            switchSpanSmall.addClass('switchery-span-small-checked');
        }else{
            if(switchSpan.hasClass("switchery-checked")){
                switchSpan.removeClass('switchery-checked');
            }
            if(switchSpanSmall.hasClass("switchery-span-small-checked")){
                switchSpanSmall.removeClass('switchery-span-small-checked');
            }
            switchSpan.addClass('switchery-unchecked');
            switchSpanSmall.addClass('switchery-span-small-unchecked');
        }
    }

}
/*checkbox点击事件*/
function changeFilterFlag(e){
    //修改样式和viewModel的值
    var thisSpanId = $(e).attr("id");//filterFlag0_switchtest_span
    var thisValue = thisSpanId.split("_")[0];//filterFlag0
    var hls_switch_input = $('#'+thisValue);
    var hls_switch_span=$(e);
    var hls_switch_small=$('#'+thisSpanId+'_small');
    hls_switch_span.toggleClass('switchery-checked');
    hls_switch_span.toggleClass('switchery-unchecked');
    hls_switch_small.toggleClass('switchery-span-small-checked');
    hls_switch_small.toggleClass('switchery-span-small-unchecked');
    var current_value = viewModelEvent.data[thisValue];//原值
    var checkedValue = 'Y';
    var uncheckedValue = 'N';
    if(current_value==checkedValue){
        viewModelEvent.data.set(thisValue,uncheckedValue);
    }else{
        viewModelEvent.data.set(thisValue,checkedValue);
    }
    //修改过滤flag
    var params = [{
        __status:"update",
        filterFlag:viewModelEvent.data[thisValue],
        eventCode:$(e).parent().attr("name")
    }];
    if(current_value==""||current_value==null){
        params[0].__status = 'add';
    }
    $.ajax({
        url: contextPath + '/hls/system/notice/filter/changeFilterFlag',
        type: "POST",
        data:JSON.stringify(params),
        dataType: "json",
        contentType: "application/json",
        success: function (datas) {
        }
    })
}

